unit NSprMo;

interface


uses NGlob,
     Dos,
     NGraph, NSprite, Mouse;

procedure SprMoInit;
procedure SprMoClose;
procedure SprMoShow;
procedure SprMoHide;
procedure PutMoSprite (PSpr: Pointer; X, Y: Integer);

const
  SprMoVis: Boolean = FALSE;
  SprMoPhase: Word = 1;
  SprMoXShift: Integer = 0;
  SprMoYShift: Integer = 0;
  SprMoMove: Boolean = FALSE;
  SprMoOk: Boolean = FALSE;

  HotMoX: Integer = 160;
  HotMoY: Integer = 75;

var
  SprMoXAct, SprMoYAct: Integer;
  SprMo: TSprDta;
  SprMoBl, SprMoAddBl: Byte;
  ForIniBl, ForIniAddBl: TVBlock;

implementation

procedure PutMoSprite (PSpr: Pointer; X, Y: Integer);
var
  XCount, YCount, IncX, XMax, YMax: Word;
begin
  XCount := PSprXY(PSpr)^.X;
  YCount := PSprXY(PSpr)^.Y;
  XMax := ActXMax;
  YMax := ActYMax;
  IncX := ActBX;
  asm
    les  di, ActBlPtr
    mov  ax, Y
    mov  bx, ActBX
    mul  bx
    mov  bx, ax
    add  di, X
    mov  dx, YCount
    push ds
    lds  si, PSpr
    add  si, 4
@@NxtStr:
    mov  cx, XCount
@@NxtByte:
    cmp  bx, YMax
    jae  @@Done
    cmp  di, XMax
    jae  @@Hole
    mov  al, byte ptr ds:[si]
    cmp  al, 0
    je   @@Hole
    mov  byte ptr es:[bx+di], al
@@Hole:
    inc  si
    inc  di
    loop @@NxtByte
    dec  dx
    add  bx, IncX
    sub  di, XCount
    cmp  dx, 0
    jg   @@NxtStr
@@Done:
    pop  ds
  end;
end;

procedure PutMoBlock (NBlock: Byte);
var
  Count: Word;
  SrcPtr, DstPtr: Pointer;
  SzX, SzY, XInc: Word;
begin
  with VBlock [NBlock] do begin
    if (PutX<0) or (PutY<0) then Exit;
    SzX := SizeX;
    SzY := SizeY;
    SrcPtr := BlPtr;
    XInc := ActBX - SzX;
    DstPtr := Pointer (LongInt (ActBlPtr) + PutY * ActBX + PutX);
  end;
  if (SzX=0) or (SzY=0) then Exit;
  asm
    push ds
    les  di, DstPtr
    lds  si, SrcPtr
    mov  dx, SzY
@@NxtStr:
    mov  cx, SzX
    rep  movsb
    add  di, XInc
    dec  dx
    cmp  dx, 0
    jg   @@NxtStr
    pop  ds
  end;
end;

procedure CutMoBlock (NBlock: Byte);
var
  SrcPtr, DstPtr: Pointer;
  SzX, SzY, XInc: Word;
begin
  with VBlock [NBlock] do begin
    if PutX + SizeX < 0 then begin PutX := -1; Exit end;
    if PutY + SizeY < 0 then begin PutY := -1; Exit end;
    if PutX > ActBX then begin PutX := -1; Exit end;
    if PutY > ActBY then begin PutY := -1; Exit end;
    if PutX < 0 then begin SizeX := SizeX + PutX; PutX := 0 end;
    if PutY < 0 then begin SizeY := SizeY + PutY; PutY := 0 end;
    if SizeX > ActBX - PutX then SizeX := ActBX - PutX;
    if SizeY > ActBY - PutY then SizeY := ActBY - PutY;
    SzX := SizeX;
    SzY := SizeY;
    DstPtr := BlPtr;
    XInc := ActBX - SzX;
    SrcPtr := Pointer (LongInt (ActBlPtr) + PutY * ActBX + PutX);
  end;
  if (SzX=0) or (SzY=0) then Exit;
  asm
    push ds
    les  di, DstPtr
    lds  si, SrcPtr
    mov  dx, SzY
@@NxtStr:
    mov  cx, SzX
    rep  movsb
    add  si, XInc
    dec  dx
    cmp  dx, 0
    jg   @@NxtStr
    pop  ds
  end;
end;

procedure FreeSprMo;
var
  i: Byte;
begin
  VBlock [SprMoBl] := ForIniBl ;
  VBlock [SprMoAddBl] := ForIniAddBl;
  FreeBlock (SprMoBl);
  FreeBlock (SprMoAddBl);
end;

function SprMoMaxSz: Word;
var
  i: Byte;
  TmpSz, MaxSz: Word;
begin
  MaxSz := 0;
  with SprMo do
    for i:=1 to NOfPhase do begin
      TmpSz := (PHead (SprPtr[i])^.X + 2) *
      PHead (SprPtr[i])^.Y;
      if TmpSz > MaxSz then MaxSz := TmpSz;
    end;
  SprMoMaxSz := MaxSz;
end;

procedure SprMoSaveBkGr;
var
  MinX, MinY, MaxX, MaxY: Integer;
begin
  with SprMo do begin
    MaxX := SprMoXAct + PHead (SprPtr[SprMoPhase])^.X;
    MaxY := SprMoYAct + PHead (SprPtr[SprMoPhase])^.Y;
    MinX := SprMoXAct;
    MinY := SprMoYAct;
  end;
  with VBlock [SprMoBl] do begin
    PutX := MinX;
    PutY := MinY;
    SizeX := MaxX - MinX ;
    SizeY := MaxY - MinY ;
  end;
  CutMoBlock (SprMoBl);
end;

procedure SprMoPutBkGr;
begin
  PutMoBlock (SprMoBl);
end;

procedure SprMoDraw;
begin
 PutVPSprite (SprMo.SprPtr [SprMoPhase], SprMoXAct, SprMoYAct);
end;

procedure DrawMouse;
var
  OldActBlock: Byte;
begin
  OldActBlock := ActBlock;
  SetActBlock (VisBlock);
  SprMoXAct := HotMoX - SprMoXShift;
  SprMoYAct := HotMoY - SprMoYShift;
  SprMoPutBkGr;
  SprMoSaveBkGr;
  SprMoDraw;
  SetActBlock (OldActBlock);
end;

procedure SprMoHide;
begin
  if SprMoVis and SprMoOK then begin
    SprMoMove := FALSE;
    SprMoPutBkGr;
    SprMoVis := FALSE;
  end;
end;

procedure SprMoShow;
begin
  if not SprMoVis and SprMoOK then begin
    SprMoXAct := HotMoX - SprMoXShift;
    SprMoYAct := HotMoY - SprMoYShift;
    SprMoSaveBkGr;
    SprMoDraw;
    SprMoMove := TRUE;
    SprMoVis := TRUE;
  end;
end;

procedure SprMoClose;
var
  i: Integer;
begin
  asm
    mov  ax, 000Ch
    mov  cx, 0
    int  33h
  end;
  SprMoHide;
  with SprMo do
  for i:=1 to NofPhase do
    FreeMem (SprPtr[i], Sz[i]);
  if not SprMoOK then Exit;
  FreeSprMo;
  SprMoOK := FALSE;
end;

procedure SprMoGetBlock;
var
  Sz: Word;
begin
  Sz := SprMoMaxSz;
  GetBlock (SprMoBl, 1, Sz);
  GetBlock (SprMoAddBl, 1, Sz);
  ForIniBl := VBlock [SprMoBl];
  ForIniAddBl := VBlock [SprMoAddBl];
end;

procedure MoInt; assembler;
asm
  push ds

  mov  ax, seg @Data
  mov  ds, ax
  mov  HotMoX, cx
  mov  HotMoY, dx
  cmp  SprMoMove, 0
  je   @@Exit

  cld
  call DrawMouse;

@@Exit:
  pop  ds
  ret
end;

procedure SprMoInit;
var
  Butt: Word;
begin
  MoInit;
  if not (MoError = moOk) then Exit;
  with VBlock [VisBlock] do begin
    MoRangeX (0, SizeX-1);
    MoRangeY (0, SizeY-1);
  end;
  MoGoToXY (HotMoX, HotMoY);
  SprMoGetBlock;
  SprMoOK := TRUE;
  SprMoXAct := HotMoX - SprMoXShift;
  SprMoYAct := HotMoY - SprMoYShift;
  SprMoSaveBkGr;
  DrawMouse;
  SprMoMove := TRUE;
  SprMoVis := TRUE;
  asm
    mov  ax, 000Ch
    mov  cl, 1
    push cs
    pop  es
    mov  dx, offset MoInt
    int  33h
  end;
end;

end.


